--- a/lib/Makefile
+++ b/lib/Makefile
@@ -195,8 +195,8 @@ install: lib liblz4.pc
 	$(INSTALL_PROGRAM) dll/$(LIBLZ4_EXP) $(DESTDIR)$(libdir)
     else
 	$(INSTALL_PROGRAM) liblz4.$(SHARED_EXT_VER) $(DESTDIR)$(libdir)
-	$(LN_SF) liblz4.$(SHARED_EXT_VER) $(DESTDIR)$(libdir)/liblz4.$(SHARED_EXT_MAJOR)
-	$(LN_SF) liblz4.$(SHARED_EXT_VER) $(DESTDIR)$(libdir)/liblz4.$(SHARED_EXT)
+	(cd $(DESTDIR)$(libdir) && $(LN_SF) liblz4.$(SHARED_EXT_VER) liblz4.$(SHARED_EXT_MAJOR))
+	(cd $(DESTDIR)$(libdir) && $(LN_SF) liblz4.$(SHARED_EXT_MAJOR) liblz4.$(SHARED_EXT))
     endif
   endif
 	@echo Installing headers in $(DESTDIR)$(includedir)
--- a/Makefile
+++ b/Makefile
@@ -77,12 +77,12 @@ build_tests:
 
 .PHONY: clean
 clean:
-	$(MAKE) -C $(LZ4DIR) $@ > $(VOID)
-	$(MAKE) -C $(PRGDIR) $@ > $(VOID)
-	$(MAKE) -C $(TESTDIR) $@ > $(VOID)
-	$(MAKE) -C $(EXDIR) $@ > $(VOID)
-	$(MAKE) -C $(FUZZDIR) $@ > $(VOID)
-	$(MAKE) -C contrib/gen_manual $@ > $(VOID)
+	$(MAKE) -C $(LZ4DIR) $@
+	$(MAKE) -C $(PRGDIR) $@
+	$(MAKE) -C $(TESTDIR) $@
+	$(MAKE) -C $(EXDIR) $@
+	$(MAKE) -C $(FUZZDIR) $@
+	$(MAKE) -C contrib/gen_manual $@
 	$(RM) lz4$(EXT)
 	$(RM) -r $(CMAKE_BUILD_DIR)
 	@echo Cleaning completed
--- a/programs/Makefile
+++ b/programs/Makefile
@@ -138,7 +138,7 @@ clean:
 ifeq ($(WINBASED),yes)
 	$(RM) *.rc
 endif
-	$(MAKE) -C $(LZ4DIR) $@ > $(VOID)
+	$(MAKE) -C $(LZ4DIR) $@
 	$(RM) core *.o *.test tmp* \
            lz4$(EXT) lz4c$(EXT) lz4c32$(EXT) lz4-wlib$(EXT) \
            unlz4$(EXT) lz4cat$(EXT)
@@ -177,16 +177,16 @@ install: lz4
 	@echo Installing binaries in $(DESTDIR)$(bindir)
 	$(INSTALL_DIR) $(DESTDIR)$(bindir)/
 	$(INSTALL_PROGRAM) lz4$(EXT) $(DESTDIR)$(bindir)/lz4$(EXT)
-	$(LN_SF) lz4$(EXT) $(DESTDIR)$(bindir)/lz4c$(EXT)
-	$(LN_SF) lz4$(EXT) $(DESTDIR)$(bindir)/lz4cat$(EXT)
-	$(LN_SF) lz4$(EXT) $(DESTDIR)$(bindir)/unlz4$(EXT)
+	(cd $(DESTDIR)$(bindir) && $(LN_SF) lz4$(EXT) lz4c$(EXT))
+	(cd $(DESTDIR)$(bindir) && $(LN_SF) lz4$(EXT) lz4cat$(EXT))
+	(cd $(DESTDIR)$(bindir) && $(LN_SF) lz4$(EXT) unlz4$(EXT))
 ifeq ($(ENABLE_DOCS),1)
 	@echo Installing man pages in $(DESTDIR)$(man1dir)
 	$(INSTALL_DIR) $(DESTDIR)$(man1dir)/
 	$(INSTALL_DATA) lz4.1 $(DESTDIR)$(man1dir)/lz4.1
-	$(LN_SF) lz4.1 $(DESTDIR)$(man1dir)/lz4c.1
-	$(LN_SF) lz4.1 $(DESTDIR)$(man1dir)/lz4cat.1
-	$(LN_SF) lz4.1 $(DESTDIR)$(man1dir)/unlz4.1
+	(cd $(DESTDIR)$(man1dir) && $(LN_SF) lz4.1 lz4c.1)
+	(cd $(DESTDIR)$(man1dir) && $(LN_SF) lz4.1 lz4cat.1)
+	(cd $(DESTDIR)$(man1dir) && $(LN_SF) lz4.1 unlz4.1)
 endif
 	@echo lz4 installation completed
 
